/*

  This file is a part of GRALESHELL, a program to facilitate the simulation
  and inversion of gravitational lenses, based on the GRALE library.

  Copyright (C) 2008-2012 Jori Liesenborgs

  Contact: jori.liesenborgs@gmail.com
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  
*/

#ifndef GRALESHELLMPIGENETICALGORITHM_H

#define GRALESHELLMPIGENETICALGORITHM_H

#include <mogal/mpigeneticalgorithm.h>
#include <list>

namespace shellp
{
	class IOSystem;
}

class GraleShellMPIGeneticAlgorithm : public mogal::MPIGeneticAlgorithm
{
public:
	GraleShellMPIGeneticAlgorithm();
	GraleShellMPIGeneticAlgorithm(const std::string &prefix);
	~GraleShellMPIGeneticAlgorithm();
private:
	void feedbackStatus(const std::string &str) const;
	void onCurrentBest(const std::list<mogal::Genome *> &bestgenomes) const;
	bool onAlgorithmLoop(mogal::GAFactory &factory, bool generationInfoChanged);
	
	bool saveintermediate;
	
	std::string prefix;
	mutable int count;

	mutable shellp::IOSystem *iosys;
};

#endif // GRALESHELLGENETICALGORITHM_H
